package sysinfo

import (
	"encoding/json"
	"time"
)

// Context is shared with every Collector.
type Context struct {
	Now      time.Time
	Logf     func(string, ...any)
	Run      func(string, ...string) ([]byte, error)
	SafeRun  func(string, ...string) string
	SafeRead func(string) string
}

// Collector produces one JSON fragment.
type Collector interface {
	Key() string
	Collect(*Context) (json.RawMessage, error)
}
